import { EventEmitter } from 'eventemitter3';
import { Component, ComponentConstructor } from './Component';
import type { Entity } from './Entity';
import { Matcher } from './Matcher';
export declare const ENTITY_EVENT: {
    Created: string;
};
export declare const COMPONENT_EVENT: {
    Added: string;
    Remove: string;
};
export declare class EntityManager extends EventEmitter {
    private componentPoolFactory;
    private entities;
    private entitiesByNames;
    /**
     * use cache when query a matcher
     */
    private matcherCache;
    getEntityByName(name: string): Entity;
    getAllEntities(): Entity[];
    queryByMatcher<C extends Component>(matcher: Matcher<C>): Entity[];
    createEntity(entity: Entity): Entity;
    destroyEntity(entity: Entity): void;
    addComponentToEntity<C extends Component<unknown>>(entity: Entity, clazz: ComponentConstructor<C>, values?: Partial<Omit<C, keyof Component<unknown>>>): C;
    removeComponentFromEntity<C extends Component<unknown>>(entity: Entity, clazz: ComponentConstructor<C>, immediately?: boolean): void;
    destroy(): void;
    private removeComponentFromEntitySync;
}
