export interface ILifecycle {
    getId(): number;
    reset(): void;
    destroy(): void;
}
export declare class ObjectPool<T extends ILifecycle> {
    private count;
    private freeList;
    protected objectFactory: () => T;
    init(T: () => T, initialSize?: number): void;
    acquire(): T;
    release(item: T): void;
    private expand;
}
