import type { ILifecycle } from './ObjectPool';
export declare class Component<C = {}> implements ILifecycle {
    readonly pid: number;
    getId(): number;
    copy(props: Partial<Omit<C, keyof Component>>): this;
    clone(): Component<C>;
    reset(): void;
    destroy(): void;
}
export interface ComponentConstructor<C extends Component> {
    readonly tag: string;
    new (props?: Partial<Omit<C, keyof Component>> | false): C;
}
