import { System, SystemConstructor } from './System';
export interface ISystemRegistry {
    register(clazz: SystemConstructor<System>): void;
    get(clazz: SystemConstructor<System>): System;
    has(clazz: SystemConstructor<System>): boolean;
}
export declare class SystemManager {
    private registry;
    private entityManager;
    private systems;
    registerSystem<S extends System>(clazz: SystemConstructor<S>): void;
    execute(delta?: number, millis?: number): void;
    destroy(): void;
    private getEntities;
}
